#COMPILE EXE
DEFLNG a - z
FUNCTION PBMAIN () AS LONG
    vcomin# = 4850000000       'Taken from page 65 of Family reference manual
    vcomax# = 5670000000
    oldf1# = 10000000
    oldf2# = 125000000
    oldfin# = 10000000
    CON.SCREEN = 60,80

    CLS
    COLOR 15
    PRINT "    Settings for the Leo Bodnar two-channel GPSDO.";
    COLOR 3 : PRINT "      G4JNT Oct 2018"
    COLOR 2 : PRINT
    PRINT "   Input the two wanted output frequencies. Values less than 500 will be
    PRINT "   interpreted as being in MHz, higher numbers are Hz. Pressing [rtn] without
    PRINT "   entering any number recalls the value used previously. If a valid solution"
    PRINT "   is possible, values will be generated for N1_HS,    NC1_LS   and NC2_LS"
    PRINT
    PRINT "   Enter a reference input to the Si5328 from the GPS source. Any value below"
    PRINT "   800 will be taken as MHz, otherwise Hz.  [rtn] recalls the previous value.
    PRINT "   Note that the M8 GPS Module used in the LB Source requires frequencies "
    PRINT "   to be an integer number of Hz"
    PRINT "   If a solution is possible, one or more values will be shown for Fcomp with
    PRINT "   associated settings for N31, N2_HS and N2_LS.
    PRINT
    PRINT "   These may not be a complete set - other options will be possible"
    PRINT
    PRINT "   When specifying frequencies with recurring decimals, enter at least"
    PRINT "   15 decimal places   eg 66.666666666666666 or 14.285714285714285 [MHz]"

    PRINT : COLOR 14
    PRINT "   @@@@@@@@@@ THIS SOFTWARE CAN NOT FIND ALL POSSIBLE SOLUTIONS @@@@@@@@@@@"
    COLOR 7
    PRINT "==========================================================================="
    DO
        PRINT
        NonExact% = 0
        COLOR 7
        INPUT "Output Freq 1 , Hz (or MHz < 500) .. ";f1#    : IF f1# < 1 THEN f1# = oldf1#  : COLOR 9 : PRINT TAB(40);f1#;"used" : COLOR 7
        IF f1# < 500 THEN f1# = f1# * 1000000
        oldf1# = f1#
        INPUT "       Freq 2               ........ ";f2#    : IF f2# < 1 THEN f2# = oldf2#  : COLOR 9 : PRINT TAB(40);f2#;"used" : COLOR 7
        IF f2# < 500 THEN f2# = f2# * 1000000
        oldf2# = f2#
        PRINT
        FOR m1count = 0 TO 2^19          'To generate 1, or 2 to 2^20 in steps of 2
            IF m1count = 0 THEN m1v = 1 ELSE m1v = 2 * m1count
            Fmid# = m1v * f1#
            m2v = Fmid# / f2#      'First hit, but may not be a multiple of 2

            IF m2v MOD 2 = 1 AND m2v > 1 THEN ITERATE FOR

            er# = ABS(m2v * f2# - m1v * f1#)
            IF er# < 1e-4 THEN EXIT FOR
        NEXT m1

        IF er# > 1e-4 THEN PRINT "    Exact LCM solution not possible"  : NonExact% = -1
        lcm# =  (m1v * f1# + m2v * f2#) / 2     'Take the average in case of a best-only solution
        COLOR 6
        PRINT "  M1 =";m1v;
        PRINT "xF1    M2 =";m2v;
        PRINT "x F2    LCM =";lcm#
        COLOR 7
        IF lcm# > 6e9 THEN COLOR 12 : PRINT "LCM too high" : ITERATE LOOP
            'Now find a common multipler which along with N1_HS gives an acceptable VCO frequency


        FOR HS = 4 TO 11
            m3min = vcomax# / lcm# / HS
            m3max = vcomin# / lcm# / HS
            IF lcm# * HS * m3max > vcomin# AND lcm# * HS * m3min < vcomax# THEN EXIT FOR
        NEXT HS

        Cmult =    INT((m3min + m3max) / 2 + .5)       'Find the common multiplier.  Use an average if several are possible
        vco# = lcm# * HS * Cmult
        COLOR 6
        PRINT "   Solution HS = ";hs;"   M3low =";m3min; "   M3high =";m3max
        IF vco# < vcomin# OR vco# > vcomax# THEN COLOR 12 : PRINT "Output folution not possible" : ITERATE LOOP
        PRINT : COLOR 7
        PRINT "====================== OUTPUT DIVIDER SETTINGS ======================="
        COLOR 6
        PRINT "VCO       = ";vco#/1e9;"GHz"
        IF NonExact% THEN COLOR 5 ELSE COLOR 11
        PRINT "    N1_HS      = ";HS
        PRINT "    NC1_LS     = ";m1v * Cmult
        PRINT "    NC2_LS     = ";m2v * Cmult
        COLOR 6
        PRINT "(Intermediate Fmid";vco#/hs/1000000;"MHz)"
        COLOR 7
        PRINT "======================================================================="
        PRINT
        IF NonExact% THEN
            PRINT "    Non exact solution :"
            PRINT "    F1 = ";vco# / HS / Cmult / m1v
            PRINT "    F2 = ";vco# / HS / Cmult / m2v
        END IF
        COLOR 7
        PRINT
        INPUT "    Input frequency Hz (or MHz if < 800)  ";fin#
        IF fin# < .0000001 THEN fin# = oldfin#  : PRINT fin#;"used"
        IF fin# < 500 THEN fin# = fin# * 1000000
        oldfin# = fin#
        COLOR 7
        PRINT
        nosolution% = -1

        fcmin# = 2000    'Minimum workable Fcomp
        PRINT "============ ALLOWABLE INPUT AND PLL DIVIDER SETTINGS ================"
        FOR x% = 0 TO 12
            fc# = Fcmin# * 10^(x% / 4)        'Approx Fcomp 2kHz to 2MHz   from family reference manuial
            IF fc# > 2000000 THEN EXIT FOR
            N3& = INT(fin# / fc#)    'Actual divider
            IF n3& < 1 THEN EXIT FOR
            fc# = fin# / N3&    'Recalculate Exact input to PD

            N2& = vco# / fc#    'Full VCO divider needed

            FOR N2h& = 4 TO 11
                N2L& = N2& / N2h&
                IF N2L& * N2h& = N2& AND N2L& MOD 2 = 0 THEN N2& = N2h& * N2L& : EXIT FOR
            NEXT N2h&

            fc2# = vco# / N2&      'Exact divided VCO

            VCOgen# = fin# / N3& * N2&
            diff = ABS(VCOgen# - vco#)
            IF diff < 1e-20 THEN
                COLOR 3
                PRINT USING$("  Fcomp = ########.###"; fc#) ;
                COLOR 15
                PRINT TAB(25);"N31 =";n3&;TAB(40);"N2_HS =";n2h&;TAB(55);"N2_LS =";n2l&
                Nosolution% = 0
            END IF
         NEXT x%
         PRINT
         IF Nosolution% THEN COLOR 12  : PRINT "No Input divider Solution" : ITERATE LOOP
         COLOR 13
         IF ABS(fin# - INT(fin#)) > .000001 THEN COLOR 12 : PRINT "Non integer value" ELSE COLOR 14
         PRINT "    Input Frequency from GPSDO ";fin# ; "Hz    ==  ";fin# / 1000000;"MHz"
         COLOR 6
         PRINT "    VCO =";vco#/1e9;"GHz";
         IF NonExact% THEN COLOR 5 ELSE COLOR 15
         PRINT TAB(25);"N1_HS  =";HS;
         PRINT TAB(40);"NC1_LS =";m1v * Cmult;
         PRINT TAB(55);"NC2_LS =";m2v * Cmult
         COLOR 14
         PRINT "    F1";f1# ; "Hz"
         PRINT "    F2";f2# ; "Hz"
         COLOR 7
         PRINT "====================================================================="
         PRINT
         COLOR 12
         PRINT "    ...  Q to Quit   Any other key to continue  ..."
         WHILE NOT INSTAT : WEND
         IF UCASE$(INKEY$) = "Q" THEN COLOR 7 : END
    LOOP
END FUNCTION
